<template>
  <div>
    {{ config.multi }}
    <div v-if="isEmpty(nodeData) || config.cardinality === -1 || !isArray(nodeData) || isArray(nodeData) && nodeData.length < config.cardinality">
      <div v-if="orderedRefs">
        <select v-model="newItemType">
          <option :value="null" :disabled="true">-- Select type --</option>
          <option v-for="ref in orderedRefs" :key="ref.id" :value="ref.id">
            {{ ref.label }}
          </option>
        </select>
        <button @click="addItem">Add</button>
      </div>
      <div v-else>
        <button @click="addItem">Add new item</button>
      </div>
    </div>
  </div>
</template>

<script>
import _ from 'lodash'

import { mapGetters, mapActions } from 'vuex'

export default {
  components: {
  },

  props: {
    node: {
      type: Object,
      required: true
    },
    path: {
      type: Array,
      required: true
    }
    // config: {
    //   type: Object,
    //   required: true
    // }
  },

  data () {
    return {
      newItemType: null
    }
  },

  computed: {
    ...mapGetters({
      getEditedField: 'Y3TI/getEditedField',
      getFieldConfig: 'Y3TI/getFieldConfig'
    }),

    config () {
      return this.getFieldConfig({ node: this.node, path: this.path })
    },

    nodeData () {
      return _.isEmpty(this.path) ? this.node : _.get(this.node, this.path, [])
    },

    orderedRefs () {
      if (!this.config.ref) {
        return false
      }
      const orderedRefs = _.orderBy(_.values(this.config.ref), ['weight'], ['asc'])
      return _.isArray(orderedRefs) && !_.isEmpty(orderedRefs) ? orderedRefs : false
    }

    // fieldsConfig () {
    //   return this.config.fields || {}
    // }
    // ...mapGetters({
    //   getEditableNodes: 'Y3TI/getEditableNodes',
    //   getFieldConfig: 'Y3TI/getFieldConfig'
    // }),

    // nodesList () {
    //   return this.getEditableNodes(this.$route.path)
    // }
    // editablePath () {
    //   return [ this.node._type, 'nid-' + this.node.nid, ...this.path ]
    // },

    // textfieldData () {
    //   return this.getEditableData(this.editablePath) || _.get(this.node, this.path)
    // }
  },

  methods: {
    ...mapActions({
      pushEditableFieldData: 'Y3TI/pushEditableFieldData',
      changeEditableParagraphType: 'Y3TI/changeEditableParagraphType',
      storeEditableFieldData: 'Y3TI/storeEditableFieldData'
    }),

    isEmpty: _.isEmpty,
    isArray: _.isArray,

    addItem () {
      if (this.config.multi) {
        this.pushEditableFieldData({ data: { path: this.path, node: this.node, config: this.config } })
        if (this.newItemType) {
          this.$nextTick(() => {
            this.changeEditableParagraphType({ data: { node: this.node, path: [...this.path, this.nodeData.length - 1], config: this.config, type: this.newItemType } })
          })
        }
      } else {
        if (this.newItemType) {
          this.changeEditableParagraphType({ data: { node: this.node, path: this.path, config: this.config, type: this.newItemType } })
        }
      }
      // if (this.config.multi) {
      //   this.pushEditableFieldData({ data: { path: this.path, node: this.node, config: this.config } })
      //   if (this.newItemType) {
      //     this.$nextTick(() => {
      //       this.changeEditableParagraphType({ data: { node: this.node, path: [...this.path, this.nodeData.length - 1], config: this.config, type: this.newItemType } })
      //     })
      //     // this.$nextTick(() => {
      //     //   this.storeEditableFieldData({ data: { node: this.node, path: [...this.path, this.nodeData.length - 1, '_type'], input: this.newItemType } })
      //     //   this.updateMultipleEditableFieldsData({ data: { node: this.node, path: [...this.path, this.nodeData.length - 1], config: this.config.ref[this.newItemType].fields } })
      //     // })
      //   }
      // } else {
      //   if (this.newItemType) {
      //     this.changeEditableParagraphType({ data: { node: this.node, path: this.path, config: this.config, type: this.newItemType } })
      //   }

      //   // this.storeEditableFieldData({ data: { node: this.node, path: this.path, input: _.get(this.config, [''], null) } })
      // }
    }
  },

  created () {
    if (this.orderedRefs) {
      this.newItemType = this.orderedRefs[0].id
    }
  }
}
</script>

<style lang="scss" scoped>
</style>
